﻿var tableCellToShow = null;
var listBoxToShow = null;
var currentTab = null;
var requestInProgress = false;
var tmpDbObjectArray = new Array();
function TabClicked(obj)
{
    if (requestInProgress) { alert("Please wait. A request is being processed."); return false; }
    objId = obj.id;
    tableCellToShow = document.getElementsByName("td" + objId)[0];
    listBoxToShow = document.getElementsByName("lb" + objId)[0];
    
    if (currentTab != null)
    {
        currentTab.className = "itab";
        TabUnClicked(currentTab);
    }
    currentTab = obj;
    tableCellToShow.style.display = "block";
    obj.className = "atab";
    if (objId == "Table" && tablesFound) { return; }
    if (objId == "View" && viewsFound) { return; }
    if (objId == "Synonym" && synonymsFound) { return; }
    if (objId == "Function" && functionsFound) { return; }
    PopulateListBoxes();
}

function TabUnClicked(obj)
{
    objId2 = obj.id;
    objToHide = document.getElementsByName("td" + objId2)[0];
    objToHide.style.display = "none";
}

function PopulateListBoxes()
{
    requestInProcess = true;
    document.form1.btnAddTables.disabled = true;
    document.form1.btnCloseAddTables.disabled = true;
    document.form1.btnRefreshAddTables.disabled = true;
    Omega.Web.MSSQL.SqlBuilder.GetObjects(currentTab.id, PopulateListBoxes_CallBack)
}

function PopulateListBoxes_CallBack(resp)
{
    requestInProcess = false;
    document.form1.btnAddTables.disabled = false;
    document.form1.btnCloseAddTables.disabled = false;
    document.form1.btnRefreshAddTables.disabled = false;
    val = resp.value;
    listBoxToShow.options.length = 0;
    //alert(val);
    if (val != null)
    {
        dbObjects = val;
        dbObjectsStr = dbObjects.toString();
        if (dbObjectsStr.indexOf("+") <= 0)
        {
            alert(dbObjectsStr);
        }
        else
        {
            for (var i=0; i<dbObjects.length; i++)
            {
                dbObject = dbObjects[i].split("+");
                tableName = dbObject[1];
                schemaName = dbObject[0];
                listBoxToShow.options[i] = new Option(tableName + " (" + schemaName + ")", dbObjects[i]);      
            }
            curTabId = currentTab.id;
            if (curTabId == "Table") { tablesFound = true; }
            if (curTabId == "View") { viewsFound = true; }
            if (curTabId == "Synonym") { synonymsFound = true; }
            if (curTabId == "Function") { functionsFound = true; }
        }
    }
}

function btnAddTables_OnClick()
{
    tmpDbObjectArray = new Array();
    
    if (listBoxTables != null && listBoxTables.options.length > 0)
    {
        for (var i=0; i<listBoxTables.options.length; i++)
        {
            if (listBoxTables.options[i].selected)
            {
                nameschema = listBoxTables.options[i].value.split("+");
                tmpDbObjectArray[tmpDbObjectArray.length] = new DBObject(2, trim(nameschema[1]), trim(nameschema[0]), trim("DBOBJ"+numberDatabaseObjectsSelectedCount), trim(nameschema[2]));
                numberDatabaseObjectsSelectedCount += 1;
                listBoxTables.options[i].selected = false;
            }
        }
    }
    if (listBoxViews != null && listBoxViews.options.length > 0)
    {
        for (var i=0; i<listBoxViews.options.length; i++)
        {
            if (listBoxViews.options[i].selected)
            {
                nameschema = listBoxViews.options[i].value.split("+");
                tmpDbObjectArray[tmpDbObjectArray.length] = new DBObject(3, trim(nameschema[1]), trim(nameschema[0]), trim("DBOBJ"+numberDatabaseObjectsSelectedCount), trim(nameschema[2]));
                numberDatabaseObjectsSelectedCount += 1;
            }
        }
    }
    if (listBoxSynonyms != null && listBoxSynonyms.options.length > 0)
    {
        for (var i=0; i<listBoxSynonyms.options.length; i++)
        {
            if (listBoxSynonyms.options[i].selected)
            {
                nameschema = listBoxSynonyms.options[i].value.split("+");
                tmpDbObjectArray[tmpDbObjectArray.length] = new DBObject(12, trim(nameschema[1]), trim(nameschema[0]), trim("DBOBJ"+numberDatabaseObjectsSelectedCount), trim(nameschema[2]));
                numberDatabaseObjectsSelectedCount += 1;
            }
        }
    }
    if (listBoxFunctions != null && listBoxFunctions.options.length > 0)
    {
        for (var i=0; i<listBoxFunctions.options.length; i++)
        {
            if (listBoxFunctions.options[i].selected)
            {
                nameschema = listBoxFunctions.options[i].value.split("+");
                tmpDbObjectArray[tmpDbObjectArray.length] = new DBObject(5, trim(nameschema[1]), trim(nameschema[0]), trim("DBOBJ"+numberDatabaseObjectsSelectedCount), trim(nameschema[2]));
                numberDatabaseObjectsSelectedCount += 1;
            }
        }
    }
    if (tmpDbObjectArray.length <= 0) { alert("Please select at least one object."); return false }
    //filter out already selected ones
    if (databaseObjects.length <= 0) 
    { 
        databaseObjects = tmpDbObjectArray; 
    }
    else
    {
        /*
        for (var i=0; i<databaseObjects.length; i++)
        {
            thisType = databaseObjects[i].type;
            thisTable = databaseObjects[i].name;
            thisSchema = databaseObjects[i].schema;
            var found = false;
            var indexOfFound = -1;
            for (var j=0; j<tmpDbObjectArray.length; j++)
            {
                newType = tmpDbObjectArray[j].type;
                newTable = tmpDbObjectArray[j].name;
                newSchema = tmpDbObjectArray[j].schema;
                if (newType == thisType && newTable == thisTable && thisSchema == newSchema)
                {
                    found = true;
                    indexOfFound = j;
                    break;                    
                }
            }    
            if (found)
            {
                var countOfExistingItems = 0;
                newType = tmpDbObjectArray[indexOfFound].type;
                newTable = tmpDbObjectArray[indexOfFound].name;
                newSchema = tmpDbObjectArray[indexOfFound].schema;
                for (var j=0; j<databaseObjects.length; j++)
                {
                    thisType = databaseObjects[i].type;
                    thisTable = databaseObjects[i].name;
                    thisSchema = databaseObjects[i].schema;
                    if (newType == thisType && newTable == thisTable && thisSchema == newSchema)
                    {
                        countOfExistingItems += 1;
                    }
                }
                while (true)
                {
                    newAlias = newTable + "_" + countOfExistingItems;    
                    if (CheckForExistingAlias(newAlias))
                    {
                        countOfExistingItems += 1;
                    }
                    else
                    {
                        break;
                    }
                }
                tmpDbObjectArray[indexOfFound].alias = newAlias;
            }
        }
        */
        for (var j=0; j<tmpDbObjectArray.length; j++)
        {
            databaseObjects[databaseObjects.length] = tmpDbObjectArray[j];
        }
    }
    DrawAddedTables(tmpDbObjectArray);
    GetColumns(tmpDbObjectArray);
    return false;
}

function btnCloseAddTables_OnClick()
{
    HidePopups_AddTables();
    return false;
}

function btnRefreshAddTables_OnClick()
{
    try
    {
        if (listBoxTables != null) { listBoxTables.options.length = 0; tablesFound = false; }
        if (listBoxViews != null) { listBoxViews.options.length = 0; viewsFound = false; }
        if (listBoxSynonyms != null) { listBoxSynonyms.options.length = 0; synonymsFound = false; }
        if (listBoxFunctions != null) { listBoxFunctions.options.length = 0; functionsFound = false; }
        TabClicked(objTabT);
    }
    catch (e)
    {
    }
    return false;
}

function ShowPopups_AddTables()
{
    objAddTables.style.display = "block";
}

function HidePopups_AddTables()
{
    objAddTables.style.display = "none";
    tmpDbObjectArray = new Array();
    HideBlankIFrame();
}

function GetColumns(tmpDbObjectArray)
{
    var dbObjs = new Array();
    var dbObjAliases = new Array();
    for (var i=0; i<tmpDbObjectArray.length; i++)
    {
        //dbObjs[i] = tmpDbObjectArray[i].schema + "." + tmpDbObjectArray[i].name;
        dbObjs[i] = tmpDbObjectArray[i].id;
        dbObjAliases[i] = tmpDbObjectArray[i].alias;
    }
    objAddTables.style.display = "none";
    objAddingTablePleaseWait.style.display = "block";
    CenterIt(objAddingTablePleaseWait);
    Omega.Web.MSSQL.SqlBuilder.GetColumnsAndForeignKeys(dbObjs, dbObjAliases, GetColumnsAndForeignKeys_Callback);
    return false;
}

function GetColumnsAndForeignKeys_Callback(resp)
{
    val = resp.value;
    objAddTables.style.display = "none";
    objAddingTablePleaseWait.style.display = "none";
    if (val != null)
    {
        columnsList = val;
        dbObjectsStr = columnsList.toString();
        if (dbObjectsStr.indexOf("+") <= 0)//There is an error in getting columns list
        {
            objAddTables.style.display = "block";
            alert(dbObjectsStr);
            //Remove all objects added recently
            for (var j=tmpDbObjectArray.length-1; j>=0; j--)
            {
                for (var i=0; i<document.getElementsByName("cbTableName").length; i++)
                {
                    if (document.getElementsByName("cbTableName")[i].value == tmpDbObjectArray[j].alias)
                    {
                       document.getElementsByName("cbTableName")[i].checked = true; 
                    }
                }
            }
            btnRemoveTables_OnClick();
            numberDatabaseObjectsSelectedCount -= tmpDbObjectArray.length;
        }
        else
        {
            //dbColumns = new Array();
            //columnNamesListForJoins = new Array();
            for (var i=0; i<foreignKeys.length; i++)
            {
                if (foreignKeys[i].table2alias == "")
                {
                    for (var j=0; j<databaseObjects.length; j++)
                    {
                        if (foreignKeys[i].schema2 + "." + foreignKeys[i].table2 == databaseObjects[j].displayName)
                        {
                            foreignKeys[i].table2alias = databaseObjects[j].alias;
                        }
                    }                
                }                
            }
            
            for (var i=0; i<columnsList.length; i++)
            {
                columnListTxt = columnsList[i].split("+");
                columnTypeIndicator = columnListTxt[0];
                if (columnTypeIndicator == "COL")
                {
                    tableAlias = trim(columnListTxt[1]);//table name
                    schemaName = trim(columnListTxt[2]);
                    tableName = trim(columnListTxt[3]);//table name
                    columnName = trim(columnListTxt[4]);
                    columnType = trim(columnListTxt[6]);//indicates if the column data type is numeric, non-numeric or all columns (*)
                    columnDataType = trim(columnListTxt[5]);//data type for column --> used in update query
                    columnId = trim(columnListTxt[7]);
                    isPK = trim(columnListTxt[8]); 
                    parentId = trim(columnListTxt[9]);
                    parentObjectType = trim(columnListTxt[10]);
                    dbColumns[dbColumns.length] = new Column(columnId, columnName, parentObjectType, parentId, tableName, schemaName, columnType, columnDataType, tableAlias, isPK);
                    if (columnName != "*")
                    {
                        columnNamesListForJoins[columnNamesListForJoins.length] = dbColumns[dbColumns.length-1].columnDisplayName;
                        if (sqlQueryType != "S")
                        {
                            columnNamesListForFilters[columnNamesListForFilters.length] = dbColumns[dbColumns.length-1].fullColumnName;
                        }
                        else
                        {
                            columnNamesListForFilters[columnNamesListForFilters.length] = dbColumns[dbColumns.length-1].columnDisplayName;
                        }    
                    }
                    columnNamesListForSelect[columnNamesListForSelect.length] = dbColumns[dbColumns.length-1].columnDisplayName;
                }
                else if (columnTypeIndicator == "REL")
                {
                    table1Alias = trim(columnListTxt[1]);//parent table alias
                    schema1Name = trim(columnListTxt[2]);//parent schema name
                    table1Name = trim(columnListTxt[3]);//parent table name
                    column1Name = trim(columnListTxt[4]);//parent column name
                    schema2Name = trim(columnListTxt[5]);//child schema name
                    table2Name = trim(columnListTxt[6]);//child table name
                    column2Name = trim(columnListTxt[7]);//child column name
                    relationshipName = trim(columnListTxt[8]);//relationship name
                    AddForeignKeysConstraint(schema1Name, table1Name, table1Alias, column1Name, schema2Name, table2Name, "", column2Name, relationshipName);
                    UpdateForeignKeysTable2Alias(schema2Name, table2Name, FindTableAlias(schema2Name, table2Name));
                }
            }
            RepopulateFilterColumnRows();
            //RepopulateJoinColumnRows();
            RepopulateSelectColumnRows();
            if (sqlQueryType == "U")
            {
                DeleteAllUpdateRows();
                CreateAllUpdateRows();
            }
            else if (sqlQueryType == "S")
            {
                AutoBuildJoins();
            }
        }
    }    
    btnCloseAddTables_OnClick();
}