﻿var columnRowIndex = -1;
var columnToBeEdited = null;
var columnMode = "A";

function InitColumnsPanel()
{
    objAddEditColumnPanel = document.getElementsByName("pnlAddEditColumn")[0];
    objColumnName = document.form1.tbColumnName;
    objColumnDataType = document.form1.ddlColumnDataType;
    objColumnLength = document.form1.tbColumnLength;
    objColumnPrecision = document.form1.tbColumnPrecision;
    objColumnScale = document.form1.tbColumnScale;
    objIsPrimaryKey = document.form1.cbPrimaryKey;
    objIsIdentityCol = document.form1.cbIdentityCol;
    objIdentitySeed = document.form1.tbIdentitySeed;
    objIdentityIncrement = document.form1.tbIdentityIncrement;
    objNullAllowed = document.form1.cbNullAllowed;
    objIsRowGuid = document.form1.cbRowGuid;
    objTbColumnDefault = document.form1.tbColumnDefault;
    objDdlDefault = document.form1.ddlDefault;
    objDdlRule = document.form1.ddlRule;
    objTbComputedColumn = document.form1.tbComputedColumn;
    objCollation = document.form1.ddlCollation;
    objTbColumnCheckConstraint = document.form1.tbColumnCheckConstraint;
}

function ShowAddEditColumnPanel()
{
    InitializeAddEditColumnPanel();
    objAddEditColumnPanel.style.display = "block";
    CenterIt(objAddEditColumnPanel);
}

function HideAddEditColumnPanel()
{
    objAddEditColumnPanel.style.display = "none";
    columnToBeEdited = null;
    columnRowIndex = -1;
    columnMode = "A";
}

function InitializeAddEditColumnPanel()
{
    columnToBeEdited = null;
    objColumnName.value = "";
    objColumnDataType.selectedIndex = 0;
    objColumnLength.className = "tfsd";
    objColumnLength.readOnly = true;
    objColumnLength.value = "";
    objColumnPrecision.className = "tfsd";
    objColumnPrecision.readOnly = true;
    objColumnPrecision.value = "";
    objColumnScale.className = "tfsd";
    objColumnScale.readOnly = true;
    objColumnScale.value = "";
    objIsPrimaryKey.disabled = false;
    objIsPrimaryKey.checked = false;
    objIsIdentityCol.disabled = false;
    objIsIdentityCol.checked = false;
    objIdentitySeed.className = "tfsd";
    objIdentitySeed.readOnly = true;
    objIdentitySeed.value = "";
    objIdentityIncrement.className = "tfsd";
    objIdentityIncrement.readOnly = true;
    objIdentityIncrement.value = "";
    objNullAllowed.disabled = false;
    objNullAllowed.checked = true;
    objIsRowGuid.disabled = false;
    objIsRowGuid.checked = false;
    objTbColumnDefault.value = "";
    objDdlDefault.selectedIndex = 0;
    objDdlRule.selectedIndex = 0;
    objTbComputedColumn.className = "tfs";
    objTbComputedColumn.readOnly = false;
    objTbComputedColumn.value = "";
    objTbColumnCheckConstraint.className = "tfs";
    objTbColumnCheckConstraint.readOnly = false;
    objTbColumnCheckConstraint.value = "";
    objCollation.selectedIndex = 0;
    objCollation.disabled = true;
}

function ddlColumnDataType_OnChange(obj)
{
    dataTypeValue = trim(obj.value.toLowerCase());
    objColumnLength.className = "tfsd";
    objColumnLength.readOnly = true;
    objColumnLength.value = "";
    objColumnPrecision.className = "tfsd";
    objColumnPrecision.readOnly = true;
    objColumnPrecision.value = "";
    objColumnScale.className = "tfsd";
    objColumnScale.readOnly = true;
    objColumnScale.value = "";
    objIsPrimaryKey.checked = false;
    objIsIdentityCol.checked = false;
    objIsIdentityCol.disabled = true;
    objIdentitySeed.className = "tfsd";
    objIdentitySeed.readOnly = true;
    objIdentitySeed.value = "";
    objIdentityIncrement.className = "tfsd";
    objIdentityIncrement.readOnly = true;
    objIdentityIncrement.value = "";
    objIsRowGuid.checked = false;
    objIsRowGuid.disabled = true;
    objNullAllowed.disabled = false;
    objCollation.selectedIndex = 0;
    objCollation.disabled = true;
    objTbComputedColumn.className = "tfs";
    objTbComputedColumn.readOnly = false;
    objTbColumnCheckConstraint.className = "tfs";
    objTbColumnCheckConstraint.readOnly = false;
    var selectedDataType = null;
    for (var i=0; i<dataTypes.length; i++)
    {
        if (dataTypes[i].Name.toLowerCase() == dataTypeValue)
        {
            selectedDataType = dataTypes[i];
            break;
        }
    }    
    if (selectedDataType != null)
    {
        var isOriginalDataType = false;            
        objColumnLength.value = selectedDataType.DefaultLength;
        if (selectedDataType.IsLengthEditable)
        {
            objColumnLength.className = "tfs";
            objColumnLength.readOnly = false;
        }
        else
        {
            objColumnLength.className = "tfsd";
            objColumnLength.readOnly = true;
        }
        objColumnPrecision.value = selectedDataType.DefaultPrecision;
        if (selectedDataType.IsPrecisionEditable)
        {
            objColumnPrecision.className = "tfs";
            objColumnPrecision.readOnly = false;
        }
        else
        {
            objColumnPrecision.className = "tfsd";
            objColumnPrecision.readOnly = true;
        }
        objColumnScale.value = selectedDataType.DefaultScale;
        if (selectedDataType.IsScaleEditable)
        {
            objColumnScale.className = "tfs";
            objColumnScale.readOnly = false;
        }
        else
        {
            objColumnScale.className = "tfsd";
            objColumnScale.readOnly = true;
        }
        if (selectedDataType.CanBeIdentityColumn)
        {
            objIsIdentityCol.disabled = false;
        }
        if (selectedDataType.CanBeRowGUIDColumn)
        {
            objIsRowGuid.disabled = false;
        }
        if (selectedDataType.IsCollationApplicable)
        {
            objCollation.disabled = false;
        }
        
        if (columnMode == "E")
        {
            if (selectedDataType.Name.toLowerCase() == columnToBeEdited.dataType.toLowerCase())
            {
                isOriginalDataType = true;  
            }
        }
        
        if (isOriginalDataType)
        {
            objColumnLength.value = columnToBeEdited.length;
            objColumnPrecision.value = columnToBeEdited.precision;
            objColumnScale.value = columnToBeEdited.scale;
            objIsIdentityCol.checked = columnToBeEdited.isIdentityColumn;
            objIdentitySeed.value = columnToBeEdited.identitySeed;
            objIdentityIncrement.value = columnToBeEdited.identityIncrement;
            objCollation.value = columnToBeEdited.collation;
            objIsPrimaryKey.checked = columnToBeEdited.isPrimaryKey;
            objNullAllowed.checked = columnToBeEdited.isNullAllowed;
            if (columnToBeEdited.isPrimaryKey)
            {
                objNullAllowed.checked = false;
                objNullAllowed.disabled = true;
            }    
        }
        else
        {
            objColumnLength.value = selectedDataType.DefaultLength;
            objColumnPrecision.value = selectedDataType.DefaultPrecision;
            objColumnScale.value = selectedDataType.DefaultScale;
        }

    }
}

function cbPrimaryKey_OnClick(obj)
{
    if (obj.checked)
    {
        objNullAllowed.checked = false;
        objNullAllowed.disabled = true;    
    }
    else
    {
        objNullAllowed.disabled = false;    
    }
    
}

function cbIdentityCol_OnClick(obj)
{
    if (obj.checked)
    {
        var existingIdentityColumn = false;
        var columnNameWithIdentity = "";
        for (var i=0; i<columns.length; i++)
        {
            if ((columns[i].isIdentityColumn) && (i != columnRowIndex) && (! columns[i].isColumnDeleted))
            {
                existingIdentityColumn = true;
                columnNameWithIdentity = columns[i].name;
                break;
            }
        }
        if (existingIdentityColumn)
        {
            alert("There can be only one identity column in a table. Column \"" + columnNameWithIdentity + "\" is currently the identity column");
            obj.checked = false;
            objIdentitySeed.className = "tfsd";
            objIdentitySeed.readOnly = true;
            objIdentityIncrement.className = "tfsd";
            objIdentityIncrement.readOnly = true;
            return false;
        }
        objIdentitySeed.className = "tfs";
        objIdentitySeed.readOnly = false;
        objIdentityIncrement.className = "tfs";
        objIdentityIncrement.readOnly = false;
        if (objIdentitySeed.value == "") { objIdentitySeed.value = "1"; }
        if (objIdentityIncrement.value == "") { objIdentityIncrement.value = "1"; }
    }
    else
    {
        objIdentitySeed.className = "tfsd";
        objIdentitySeed.readOnly = true;
        objIdentityIncrement.className = "tfsd";
        objIdentityIncrement.readOnly = true;
    }
    return false;
}

function cbRowGuid_OnClick(obj)
{

}

function ddlDefault_OnChange(obj)
{
    objTbColumnDefault.value = trim(objTbColumnDefault.value);
    var proceed = true;
    if (objTbColumnDefault.value != "")
    {
        proceed = window.confirm("Change the value of existing default value for column?");
    }
    if (proceed)
    {
        objTbColumnDefault.value = trim(obj.value);
    }
}

function ddlRule_OnChange(obj)
{
}

function btnNewColumn_OnClick()
{
    columnMode = "A";
    ShowAddEditColumnPanel();
    objColumnName.focus();
    return false;
}


function btnSaveColumn_OnClick()
{
    if (ValidateColumn())
    {
        if (columnMode == "A")
        {
           btnNewColumn_OnClick(); 
        }
        else
        {
            btnCancelColumn_OnClick();
        }    
    }
    return false;
}

function btnCancelColumn_OnClick()
{
    HideAddEditColumnPanel();
    return false;
}

function ValidateColumn()
{
    objColumnName.value = trim(objColumnName.value);
    objColumnDataType.value = trim(objColumnDataType.value);
    objColumnLength.value = trim(objColumnLength.value);
    objColumnPrecision.value = trim(objColumnPrecision.value);
    objColumnScale.value = trim(objColumnScale.value);
    objIdentitySeed.value = trim(objIdentitySeed.value);
    objIdentityIncrement.value = trim(objIdentityIncrement.value);
    objTbColumnDefault.value = trim(objTbColumnDefault.value);
    objDdlRule.value = trim(objDdlRule.value);
    objTbColumnCheckConstraint.value = trim(objTbColumnCheckConstraint.value);
    dataTypeText = "";
    if (objColumnName.value == "") 
    { 
        alert("Column name is required.");
        objColumnName.focus();
        return false;
    }    
    //Check for valid column name
    //First character can either be an underscore (_) or a letter.
    firstChar = objColumnName.value.charAt(0).toLowerCase();
    if (! (firstChar == "_" || (firstChar >= 'a' && firstChar <= 'z')))
    {
        alert("Invalid column name. Column name must begin with an underscore (_) or a letter (a-z OR A-Z)");
        objColumnName.select();
        return false;
    }
    //Check for duplicate column name
    for (var i=0; i<columns.length; i++)
    {
        if ( (! columns[i].isColumnDeleted) && (columns[i].name.toLowerCase() == objColumnName.value.toLowerCase()) )
        {
            if (i != columnRowIndex)
            {
                alert("Duplicate column name found. Column names must be unique in a table");
                objColumnName.select();
                return false;
            }
        }
    }
    if (objColumnDataType.value == "") 
    { 
        alert("Column data type is required.");
        objColumnDataType.focus();
        return false;
    }    
    var selectedDataType = null;
    for (var i=0; i<dataTypes.length; i++)
    {
        if (dataTypes[i].Name.toLowerCase() == objColumnDataType.value.toLowerCase())
        {
            selectedDataType = dataTypes[i];
            break;
        }
    }    
    if (selectedDataType != null)
    {
        if (selectedDataType.IsLengthEditable)
        {
            minLength = selectedDataType.MinimumLength;
            maxLength = selectedDataType.MaximumLength;
            if (! CheckInteger(objColumnLength, minLength, maxLength))
            {
                objColumnLength.select();
                return false;
            }
        }
        if (selectedDataType.IsPrecisionEditable)
        {
            minPrecision = selectedDataType.MinimumPrecision;
            maxPrecision = selectedDataType.MaximumPrecision;
            if (! CheckInteger(objColumnPrecision, minPrecision, maxPrecision))
            {
                objColumnPrecision.select();
                return false;
            }
        }
        if (selectedDataType.IsScaleEditable)
        {
            minScale = selectedDataType.MinimumScale;
            maxScale = selectedDataType.MaximumScale;
            if (! CheckInteger(objColumnScale, minScale, maxScale))
            {
                objColumnScale.select();
                return false;
            }
        }
        if (! selectedDataType.IsCollationApplicable)
        {
            objCollation.selectedIndex = 0;
        }
        if (selectedDataType.IsPrecisionEditable && selectedDataType.IsScaleEditable)
        {
            if (objPrecision.value != "" && objScale.value != "")
            {
                if (parseInt(objColumnPrecision.value, 10) <= parseInt(objColumnScale.value, 10))
                {
                    alert("Precision value should be greater than scale value");
                    objColumnScale.select();
                    return false;
                }
            }
        }
        dataTypeText = selectedDataType.Format;
        dataTypeText = dataTypeText.replace("$Name$", selectedDataType.Name);
        dataTypeText = dataTypeText.replace("$Length$", objColumnLength.value);
        dataTypeText = dataTypeText.replace("$Precision$", objColumnPrecision.value);
        dataTypeText = dataTypeText.replace("$Scale$", objColumnScale.value);
    }
    if (objIsIdentityCol.checked)
    {
        if (! isInteger(objIdentitySeed.value, true, false))
        {
            alert("Please enter a valid value for indetity seed");
            objIdentitySeed.select();
            return false;
        }
        if (! isInteger(objIdentityIncrement.value, false, false))
        {
            alert("Please enter a valid value for indetity increment");
            objIdentityIncrement.select();
            return false;
        }
    }
    else
    {
       objIdentitySeed.value = "";
       objIdentityIncrement.value = ""; 
    }
    thisDefault = trim(objTbColumnDefault.value);
    isDefaultAFunction = false;
    isDefaultSystemDefault = false;
    if (! (thisDefault == "" || isDefaultSystemDefault))
    {
        retValue = Omega.Web.MSSQL.UserDefinedFunctionDesigner.IsSQLFunction(thisDefault);        
        if (retValue.value == "Y")
        {
            isDefaultAFunction = true;
        }
    }
    if (columnMode == "A")
    {
        var tc = new TableColumn(-1, objColumnName.value, objColumnDataType.value, dataTypeText, objColumnLength.value, objColumnPrecision.value, objColumnScale.value, objIsPrimaryKey.checked, objIsIdentityCol.checked, objIdentitySeed.value, objIdentityIncrement.value, objNullAllowed.checked, objIsRowGuid.checked, thisDefault, "N", thisDefault, trim(objDdlRule.value), trim(objTbComputedColumn.value), trim(objCollation.value), trim(objTbColumnCheckConstraint.value));
        tc.isDefaultAFunction = isDefaultAFunction;
        tc.isDefaultSystemDefault = isDefaultSystemDefault;
        columns[columns.length] = tc;
        PaintNewColumnRow(tc, columns.length-1);
    }
    else if (columnMode == "E")
    {
        var tc = new TableColumn(columnToBeEdited.id, objColumnName.value, objColumnDataType.value, dataTypeText, objColumnLength.value, objColumnPrecision.value, objColumnScale.value, objIsPrimaryKey.checked, objIsIdentityCol.checked, objIdentitySeed.value, objIdentityIncrement.value, objNullAllowed.checked, objIsRowGuid.checked, trim(objTbColumnDefault.value), columnToBeEdited.isAutoDefaultConstraint, columnToBeEdited.defaultName, trim(objDdlRule.value), trim(objTbComputedColumn.value), trim(objCollation.value), trim(objTbColumnCheckConstraint.value));
        tc.isDefaultAFunction = isDefaultAFunction;
        tc.isDefaultSystemDefault = isDefaultSystemDefault;
        columns[columnRowIndex] = tc;
        PaintEditColumnRow(tc, columnRowIndex);
    }
    return true;
}

function EditColumn(columnIndex)
{
    try
    {
        InitializeAddEditColumnPanel();
        columnRowIndex = columnIndex;
        columnToBeEdited = columns[columnIndex];
        columnMode = "E";
        objColumnName.value = columnToBeEdited.name;
        objColumnDataType.value = columnToBeEdited.dataType;
        ddlColumnDataType_OnChange(objColumnDataType);
        objColumnLength.value = columnToBeEdited.length;
        objColumnPrecision.value = columnToBeEdited.precision;
        objColumnScale.value = columnToBeEdited.scale;
        objIsPrimaryKey.checked = columnToBeEdited.isPrimaryKey;
        objIsIdentityCol.checked = columnToBeEdited.isIdentityColumn;
        objIdentitySeed.value = columnToBeEdited.identitySeed;
        objIdentityIncrement.value = columnToBeEdited.identityIncrement;
        objNullAllowed.checked = columnToBeEdited.isNullAllowed;
        objIsRowGuid.checked = columnToBeEdited.isRowGuid;
        objTbColumnDefault.value = columnToBeEdited.defaultValue;
        objDdlRule.value = columnToBeEdited.rule;
        objTbComputedColumn.value = columnToBeEdited.formula;
        objCollation.value = columnToBeEdited.collation;
        objTbColumnCheckConstraint.value = columnToBeEdited.columnCheckConstraint;
        objAddEditColumnPanel.style.display = "block";
        objColumnName.select();
        CenterIt(objAddEditColumnPanel);
    }
    catch (e)
    {
    }
}

function PaintEditColumnRow(editedColumn, rowIndex)
{
    if (isIE)
    {
        tr = document.getElementById("cor_" + rowIndex);
        //Primary Key
        td = tr.cells(0);
        td.innerHTML = editedColumn.isPrimaryKey ? pkText : "&nbsp;";
        //Column Name;
        td = tr.cells(1);
        td.align = "left";
        td.innerHTML = editedColumn.name;
        //Column Data Type;
        td = tr.cells(2);
        td.align = "left";
        td.innerHTML = editedColumn.dataTypeText;
        //Nulls Allowed
        td = tr.cells(3);
        td.innerHTML = editedColumn.isNullAllowed ? trueText : "&nbsp;";
        //Is Identity Column
        td = tr.cells(4);
        td.innerHTML = editedColumn.isIdentityColumn ? trueText : "&nbsp;";
        if (editedColumn.isIdentityColumn)
        {
            //identity seed
            td = tr.cells(5);
            td.innerHTML = editedColumn.identitySeed;

            //identity increment
            td = tr.cells(6);
            td.innerHTML = editedColumn.identityIncrement;
        }
        else
        {
            //identity seed
            td = tr.cells(5);
            td.innerHTML = "&nbsp;";

            //identity increment
            td = tr.cells(6);
            td.innerHTML = "&nbsp;";
        }
        //Is RowGUID Column
        td = tr.cells(7);
        td.innerHTML = editedColumn.isRowGuid ? trueText : "&nbsp;";
    }
    else
    {
    }
}

function PaintNewColumnRow(newColumn, thisColumnIndex)
{
    if (isIE)
    {
        tr = objColumnsTable.insertRow();
        //thisColumnIndex = columns.length - 1;
        rowid = "cor_" + thisColumnIndex;
        tr.id = rowid;
        tr.setAttribute("name", rowid);
        //Primary Key
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = newColumn.isPrimaryKey ? pkText : "&nbsp;";
        //Column Name;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newColumn.name;
        //Column Data Type;
        td = tr.insertCell();
        td.className = "cdat";
        td.align = "left";
        td.innerHTML = newColumn.dataTypeText;
        //Nulls Allowed
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = newColumn.isNullAllowed ? trueText : "&nbsp;";
        //Is Identity Column
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = newColumn.isIdentityColumn ? trueText : "&nbsp;";
        if (newColumn.isIdentityColumn)
        {
            //identity seed
            td = tr.insertCell();
            td.className = "cdat";
            td.innerHTML = newColumn.identitySeed;

            //identity increment
            td = tr.insertCell();
            td.className = "cdat";
            td.innerHTML = newColumn.identityIncrement;
        }
        else
        {
            //identity seed
            td = tr.insertCell();
            td.className = "cdat";
            td.innerHTML = "&nbsp;";

            //identity increment
            td = tr.insertCell();
            td.className = "cdat";
            td.innerHTML = "&nbsp;";
        }
        //Is RowGUID Column
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = newColumn.isRowGuid ? trueText : "&nbsp;";
        //Edit & Delete
        editHTML = "<a href='#' onClick='EditColumn(" + thisColumnIndex + ")' title='Edit Column'>" + editText + "</a>";
        deleteHTML = "<a href='#' onClick='DeleteColumn(" + thisColumnIndex + ")' title='Delete Column'>" + deleteText + "</a>";
        td = tr.insertCell();
        td.className = "cdat";
        td.innerHTML = editHTML + "&nbsp;&nbsp;" + deleteHTML;
    }
}    

function DeleteColumn(columnIndex)
{
    thisColumn = columns[columnIndex];
    var confirmDelete = true;
    if (thisColumn.id >= 0)
    {
        confirmDelete = window.confirm("Are you sure you want to delete this column?");
    }
    if (confirmDelete)
    {
        thisColumn.isColumnDeleted = true;
        columns[columnIndex] = thisColumn;
        rowObjId = "cor_" + columnIndex;
        rowObj = document.getElementsByName(rowObjId)[0];
		if (isIE) { ri = rowObj.rowIndex; objColumnsTable.deleteRow(ri); }
		else { deletedRow = objColumnsTable.removeChild(rowObj); }
    }
}




