﻿var objUdfDesigner = null;
var objSchema = null;
var objUdfName = null;
var objPropertiesPanel = null;
var objParametersPanel = null;
var objColumnsPanel = null;
var objSQLPanel = null;
var objBodyPanel = null;
var objPropertiesTab = null;
var objParametersTab = null;
var objColumnsTab = null;
var objSQLTab = null;
var objBodyTab = null;
var objUdfType = null;
var objReturnDataType = null;
var objReturnTableVariableName = null;
var objCbEncryptedUdf = null;
var objCbSchemaBoundUdf = null;
var objCbReturnsNullOnNullInputUdf = null;
var objExecuteAs = null;
var objTbCode = null;
var objTbSQL = null;
var objTablePleaseWait = null;
var objCellPleaseWaitMessage = null;

var objParametersTable = null;
var objAddEditParameterPanel = null;
var objParameterName = null;
var objParameterDataType = null;
var objParameterLength = null;
var objParameterPrecision = null;
var objParameterScale = null;
var objParameterIsReadonly = null;
var objParameterDefaultValue = null;

var objAddEditColumnPanel = null;
var objColumnsTable = null;
var objColumnName = null;
var objColumnDataType = null;
var objColumnLength = null;
var objColumnPrecision = null;
var objColumnScale = null;
var objIsPrimaryKey = null;
var objIsIdentityCol = null;
var objIdentitySeed = null;
var objIdentityIncrement = null;
var objNullAllowed = null;
var objIsRowGuid = null;
var objTbColumnDefault = null;
var objDdlDefault = null;
var objDdlRule = null;
var objCollation = null;
var objTbComputedColumn = null;
var objTbColumnCheckConstraint = null;

var udfMode = "N";

function BodyOnLoad()
{
    try
    {
        objUdfDesigner = document.getElementsByName("tblUdfDesigner")[0];
        objSchema = document.form1.ddlSchema;
        objUdfName = document.form1.tbUdfName;
        objPropertiesPanel = document.getElementsByName("pnlProperties")[0];
        objParametersPanel = document.getElementsByName("pnlParameters")[0];
        objColumnsPanel = document.getElementsByName("pnlColumns")[0];
        objBodyPanel = document.getElementsByName("pnlBody")[0];
        objSQLPanel = document.getElementsByName("pnlSQL")[0];
        objPropertiesTab = document.getElementsByName("tabProperties")[0];
        objParametersTab = document.getElementsByName("tabParameters")[0];
        objColumnsTab = document.getElementsByName("tabColumns")[0];
        objSQLTab = document.getElementsByName("tabSQL")[0];
        objBodyTab = document.getElementsByName("tabBody")[0];
        
        objUdfType = document.form1.ddlUdfType;
        objReturnDataType = document.form1.ddlReturnDataType;
        objReturnTableVariableName = document.form1.tbReturnTableVariableName;
        objCbEncryptedUdf = document.form1.cbEncryptedUdf;
        objCbSchemaBoundUdf = document.form1.cbSchemaBoundUdf;
        objCbReturnsNullOnNullInputUdf = document.form1.cbReturnsNullOnNullInputUdf;
        objExecuteAs = document.form1.ddlExecuteAs;
        
        objTbCode = document.form1.tbCode;
        objTbSQL = document.form1.tbSQL;
        
        objParametersTable = document.getElementsByName("tblParameters")[0];
        objColumnsTable = document.getElementsByName("tblColumns")[0];
        
        objTablePleaseWait = document.getElementsByName("tblPleaseWait")[0];
        objCellPleaseWaitMessage = document.getElementsByName("cellPleaseWaitMessage")[0];

        InitParametersPanel();
        if (parameters != null && parameters.length > 0)
        {
            for (var i=0; i<parameters.length; i++)
            {
                PaintNewParameterRow(parameters[i], i);
            }
        }
        InitColumnsPanel();
        if (columns != null && columns.length > 0)
        {
            for (var i=0; i<columns.length; i++)
            {
                PaintNewColumnRow(columns[i], i);
            }
        }
    }
    catch (e)
    {
    }
}

function PropertiesTabClicked(obj)
{
    HideAddEditParameterPanel();
    HideAddEditColumnPanel();
    objPropertiesTab.className = "atabr";
    objParametersTab.className = "itabr";
    objColumnsTab.className = "itabr";
    objBodyTab.className = "itabr";
    objSQLTab.className = "itabr";

    objPropertiesPanel.style.display = "block";
    objParametersPanel.style.display = "none";
    objColumnsPanel.style.display = "none";
    objBodyPanel.style.display = "none";
    objSQLPanel.style.display = "none";
    return false;
}

function ParametersTabClicked(obj)
{
    HideAddEditParameterPanel();
    HideAddEditColumnPanel();
    objPropertiesTab.className = "itabr";
    objParametersTab.className = "atabr";
    objColumnsTab.className = "itabr";
    objBodyTab.className = "itabr";
    objSQLTab.className = "itabr";

    objPropertiesPanel.style.display = "none";
    objParametersPanel.style.display = "block";
    objColumnsPanel.style.display = "none";
    objBodyPanel.style.display = "none";
    objSQLPanel.style.display = "none";
    return false;
}


function ColumnsTabClicked(obj)
{
    HideAddEditParameterPanel();
    HideAddEditColumnPanel();
    if (objUdfType.value != "T")
    {
        alert("You can only define columns if the function type is a \"Table Valued\" function.");
        return false;
    }
    objPropertiesTab.className = "itabr";
    objParametersTab.className = "itabr";
    objColumnsTab.className = "atabr";
    objBodyTab.className = "itabr";
    objSQLTab.className = "itabr";

    objPropertiesPanel.style.display = "none";
    objParametersPanel.style.display = "none";
    objColumnsPanel.style.display = "block";
    objBodyPanel.style.display = "none";
    objSQLPanel.style.display = "none";
    return false;
}


function BodyTabClicked(obj)
{
    HideAddEditParameterPanel();
    HideAddEditColumnPanel();
    objPropertiesTab.className = "itabr";
    objParametersTab.className = "itabr";
    objColumnsTab.className = "itabr";
    objBodyTab.className = "atabr";
    objSQLTab.className = "itabr";

    objPropertiesPanel.style.display = "none";
    objParametersPanel.style.display = "none";
    objColumnsPanel.style.display = "none";
    objBodyPanel.style.display = "block";
    objSQLPanel.style.display = "none";
    return false;
}


function SQLTabClicked(obj)
{
    if (ValidateUserDefinedFunction())
    {
        HideAddEditParameterPanel();
        HideAddEditColumnPanel();
        objPropertiesTab.className = "itabr";
        objParametersTab.className = "itabr";
        objColumnsTab.className = "itabr";
        objBodyTab.className = "itabr";
        objSQLTab.className = "atabr";

        objPropertiesPanel.style.display = "none";
        objParametersPanel.style.display = "none";
        objColumnsPanel.style.display = "none";
        objBodyPanel.style.display = "none";
        objSQLPanel.style.display = "block";

        if (udfMode == "N")
        {
            objTbSQL.value = "-- Preparing user defined function create script, please wait";
        }
        else
        {
            objTbSQL.value = "-- Preparing user defined function alter script, please wait";
        }
        Omega.Web.MSSQL.UserDefinedFunctionDesigner.BuildCreateOrAlterUserDefinedFunctionSQLStatement(parseInt(document.form1.udfId.value, 10), trim(objSchema.value), trim(objUdfName.value), trim(objUdfType.value), trim(objReturnDataType.value), trim(objReturnTableVariableName.value), objCbEncryptedUdf.checked, objCbSchemaBoundUdf.checked, objCbReturnsNullOnNullInputUdf.checked, trim(objExecuteAs.value), parameters, columns, trim(objTbCode.value), BuildCreateOrAlterUserDefinedFunctionSQLStatement_Callback);
    }
    return false;
}

function BuildCreateOrAlterUserDefinedFunctionSQLStatement_Callback(resp)
{
    objTbSQL.value = resp.value;
    return false;
}

function ddlUdfType_OnChange(obj)
{
    functionType = obj.value;
    objReturnDataType.disabled = true;
    objReturnTableVariableName.readOnly = true;
    objReturnTableVariableName.className = "tfsd";
    if (functionType == "I")
    {
    }
    else if (functionType == "T")
    {
        objReturnTableVariableName.readOnly = false;
        objReturnTableVariableName.className = "tfs";
        objReturnTableVariableName.focus();
    }
    else if (functionType == "S")
    {
        objReturnDataType.disabled = false;
        objReturnDataType.focus();
    }
}

function ddlReturnDataType_OnChange(obj)
{
    return false;
}

function btnTestSql_OnClick()
{
    HideAddEditParameterPanel();
    HideAddEditColumnPanel();
    if (ValidateUserDefinedFunction())
    {
        objUdfDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = checkSqlText;
        Omega.Web.MSSQL.UserDefinedFunctionDesigner.ValidateSql(parseInt(document.form1.udfId.value, 10), trim(objSchema.value), trim(objUdfName.value), trim(objUdfType.value), trim(objReturnDataType.value), trim(objReturnTableVariableName.value), objCbEncryptedUdf.checked, objCbSchemaBoundUdf.checked, objCbReturnsNullOnNullInputUdf.checked, trim(objExecuteAs.value), parameters, columns, trim(objTbCode.value), ValidateSql_Callback);
    }
    return false;
}

function ValidateSql_Callback(resp)
{
    alert(resp.value);
    objUdfDesigner.style.display = "block";
    objTablePleaseWait.style.display = "none";
}

function btnExecuteSql_OnClick()
{
    HideAddEditParameterPanel();
    HideAddEditColumnPanel();
    if (ValidateUserDefinedFunction())
    {
        objUdfDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = savingTableText;
        Omega.Web.MSSQL.UserDefinedFunctionDesigner.CreateOrAlterUserDefinedFunction(parseInt(document.form1.udfId.value, 10), trim(objSchema.value), trim(objUdfName.value), trim(objUdfType.value), trim(objReturnDataType.value), trim(objReturnTableVariableName.value), objCbEncryptedUdf.checked, objCbSchemaBoundUdf.checked, objCbReturnsNullOnNullInputUdf.checked, trim(objExecuteAs.value), parameters, columns, trim(objTbCode.value), CreateOrAlterUserDefinedFunction_Callback);
    }
    return false;
}

function CreateOrAlterUserDefinedFunction_Callback(resp)
{
    respval = resp.value;
    isError = true;
    message = "Unable to update the database";
    if (respval != null)
    {
        respvalarray = respval.split("|");
        message = respvalarray[1];
        if (respval.charAt(0) == "0")
        {
            isError = false;
        }
    }
    alert(message);
    if (isError)
    {
        objUdfDesigner.style.display = "block";
        objTablePleaseWait.style.display = "none";
    }
    else
    {
        window.opener.UDFDesignerComplete(udfMode, document.form1.udfId.value, trim(objUdfName.value));
        self.close();
    }
}

function ValidateUserDefinedFunction()
{
    udfidid = document.form1.udfId.value;
    if (parseInt(udfidid, 10) > 0)
    {
        udfMode = "E";
    }
    objUdfName.value = trim(objUdfName.value);
    if (objUdfName.value == "")
    {
        alert("Function name is required");
        objUdfName.focus();
        return false;
    }
    objTbCode.value = trim(objTbCode.value);
    if (objTbCode.value == "")
    {
        alert("Function body is required");
        BodyTabClicked(null);
        objTbCode.focus();
        return false;
    }    
    objReturnTableVariableName.value = trim(objReturnTableVariableName.value);
    if (objUdfType.value == "T")
    {
        returnTableVariableName = objReturnTableVariableName.value;
        firstChar = returnTableVariableName.charAt(0).toLowerCase();
        if (firstChar != "@")
        {
            alert("Invalid return table variable name. Return table variable name name must begin with an at sign (@)");
            PropertiesTabClicked(null);
            objReturnTableVariableName.select();
            return false;
        }
        if (returnTableVariableName.length < 2)
        {
            alert("Invalid return table variable name name length.");
            PropertiesTabClicked(null);
            objReturnTableVariableName.select();
            return false;
        }
        numColumns = columns.length;
        for (var i=0; i<columns.length; i++)
        {
            if (columns[i].isColumnDeleted)
            {
                numColumns--;
            }
        }
        if (numColumns <= 0)
        {
            alert("Please define at least one column for the table");
            ColumnsTabClicked(null);
            btnNewColumn_OnClick();
            return false;
        }
    }
    else
    {
        objReturnTableVariableName.value = "";
    }
    return true;
}