﻿var objTableEnvelope = null;
var objConnectionInfo = null;
var objConnectionInProgress = null;
var objConnectToDatabase = null;
var objActivityMessage = null;
var objServerName = null;
var objUserName = null;
var objPassword = null;
var objDBName = null;
var objConnectionTimeout = null;
var objAuthType = null;
var objDomain = null;
var authenticationType = 0;
function BodyOnLoad()
{
    objTableEnvelope = document.getElementsByName("tblEnvelope")[0];
    var screenDimension = GetScreenSize(false);
    if (isFireFox)
    {
        objTableEnvelope.style.width = screenDimension.width + "px;";
        objTableEnvelope.style.height = screenDimension.height - 18 + "px;";
    }
    else
    {
        objTableEnvelope.style.width = screenDimension.width;
        objTableEnvelope.style.height = screenDimension.height;
    }
    objConnectionInfo = document.getElementsByName("divConnectionInfo")[0];
    objConnectionInProgress = document.getElementsByName("divConnectionInProgress")[0];
    objConnectToDatabase = document.getElementsByName("divConnectToDatabase")[0];
    objActivityMessage = document.getElementsByName("divActivityMessage")[0];
    objAuthType = document.getElementsByName("authType");
    objDomain = document.form1.tbDomain;
    objServerName = document.form1.tbDbServer;
    objUserName = document.form1.tbUsername;
    objPassword = document.form1.tbPassword;
    objDBName = document.form1.ddlDBName;
    objConnectionTimeout = document.form1.ddlConnectionTimeout;
    objConnectionInfo.style.display = "block";
    objConnectionInProgress.style.display = "none";
    objConnectToDatabase.style.display = "none";
    authType_OnClick();
    objServerName.select();
    return false;
}

function authType_OnClick()
{
    for (var i=0; i<objAuthType.length; i++)
    {
        if (objAuthType[i].checked)
        {
            authenticationType = parseInt(objAuthType[i].value);
        }
    }
    if (authenticationType == INTEGRATED)
    {
        objDomain.className = "tfs";
        objDomain.readOnly = false;
        objDomain.select();
    }
    else
    {
        objDomain.className = "tfsd";
        objDomain.readOnly = true;
        objDomain.value = "";
    }
}
function Validate()
{
    objServerName.value = trim(objServerName.value);
    objUserName.value = trim(objUserName.value);
    objPassword.value = trim(objPassword.value);
    objDomain.value = trim(objDomain.value);
    if (objServerName.value.length == 0) 
    { 
        alert("Please enter the database server you want to connect to"); 
        objServerName.focus();
        return false;
    }
    if (! (authenticationType == INTEGRATED || authenticationType == SQL_SERVER))
    {
        authenticationType = SQL_SERVER;
    }
    else if (authenticationType == INTEGRATED)
    {
        if (objDomain.value.length == 0)
        {
            alert("Please specify the login domain");
            objDomain.select();
            return false;
        } 
    }
    if (objUserName.value.length == 0) 
    { 
        if (authenticationType == SQL_SERVER)
        {
            alert("Please enter the username using which you want to connect to the database."); 
        }
        else
        {
            alert("Please enter your network username."); 
        }
        objUserName.focus();
        return false;
    }
    if (objPassword.value.length == 0) 
    { 
        if (authenticationType == SQL_SERVER)
        {
            if (! window.confirm("Are you sure you want to connect to the database with an empty password?"))
            {
                objPassword.focus();
                return false;
            }
        }
        else
        {
            alert("Please enter your network password."); 
            objUserName.focus();
            return false;
        }
    }
        
    objConnectionInfo.style.display = "none";
    objConnectionInProgress.style.display = "block";
    AjaxPro.timeoutPeriod = (parseInt(objConnectionTimeout.value, 10)+10) * 1000;
    if (authenticationType == INTEGRATED)
    {
        objActivityMessage.innerHTML = "Authenticating user credentials, please wait ...";
        Omega.Web.MSSQL._Default.AuthenticateNetworkCredentials(objDomain.value, objUserName.value, objPassword.value, CheckNetworkCredentials_CallBack);
    }
    else
    {
        objActivityMessage.innerHTML = "Connecting to the database, please wait ...";
        Omega.Web.MSSQL._Default.CheckDatabaseConnection(objServerName.value, "", authenticationType, objDomain.value, objUserName.value, objPassword.value, parseInt(objConnectionTimeout.value, 10), CheckDBConnectionStep1_CallBack);
    }
    return false;
}

function CheckNetworkCredentials_CallBack(response)
{
    userAuthenticated = response.value;
    if (userAuthenticated)
    {
        objConnectionInfo.style.display = "none";
        objConnectionInProgress.style.display = "block";
        objActivityMessage.innerHTML = "Connecting to the database, please wait ...";
        Omega.Web.MSSQL._Default.CheckDatabaseConnection(objServerName.value, "", authenticationType, objDomain.value, objUserName.value, objPassword.value, parseInt(objConnectionTimeout.value, 10), CheckDBConnectionStep1_CallBack);
    }
    else
    {
        alert("Unable to authenticate the user using domain/username/password information provided. Please check the information and try again.");
        objConnectionInfo.style.display = "block";
        objConnectionInProgress.style.display = "none";
        objDomain.select();
    }
    return false;
}

function CheckDBConnectionStep1_CallBack(response)
{
    retVal = response.value;
    if (! (retVal == "-1" || retVal == "-2" || retVal == "-3"))
    {
        if (retVal == "8" || retVal == "9" || retVal == "10")
        {
            objActivityMessage.innerHTML = "Connection to the database established. Now getting the list of databases, please wait ...";
            Omega.Web.MSSQL._Default.GetAvailableDatabases(objServerName.value, "", authenticationType, objDomain.value, objUserName.value, objPassword.value, parseInt(objConnectionTimeout.value, 10), parseInt(retVal, 10), GetAvailableDatabases_CallBack);
        }
    }
    else if (retVal == "-1")
    {
        alert("Unable to connect to the database server. Please check the parameters and try again.");
        objConnectionInfo.style.display = "block";
        objConnectionInProgress.style.display = "none";
        objServerName.select();
    }
    else if (retVal == "-2")
    {
        alert("Currently this version of Omega.MSSQL can only connect to SQL Server 2000 & 2005. You are trying to connect to an unsupported version.");
        objConnectionInfo.style.display = "block";
        objConnectionInProgress.style.display = "none";
        objServerName.select();
    }
    else if (retVal == "-3")
    {
        alert("This copy of software is not licensed for the specified database server. Please contact your administrator.");
        objConnectionInfo.style.display = "block";
        objConnectionInProgress.style.display = "none";
        objServerName.select();
    }
    else
    {
        alert("Unable to connect to the database server. Please check the parameters and try again.");
        objConnectionInfo.style.display = "block";
        objConnectionInProgress.style.display = "none";
        objServerName.select();
    }
}


function GetAvailableDatabases_CallBack(response)
{
    databaseList = response.value.toString();
    databaseList = trim(databaseList);
	dbList = databaseList.split(",");
    if (databaseList.length == 0 || dbList.length <= 0)
    {
        alert("Unable to retrieve the list of databases. Please check the parameters and try again.");
        objConnectionInfo.style.display = "block";
        objConnectionInProgress.style.display = "none";
        objServerName.select();
        return;
    }
    objDBName.options.length = 1;
    for (var i=0; i<dbList.length; i++)
    {
        objDBName.options[objDBName.options.length] = new Option(dbList[i], dbList[i]);
    }
    if (dbList.length == 1)
    {
        objDBName.selectedIndex = 1;
        ValidateConnectionToSpecificDB();
    }
    else
    {
        objConnectToDatabase.style.display = "block";
        objConnectionInProgress.style.display = "none";
        objDBName.focus();
    }
}

function ValidateConnectionToSpecificDB()
{
    if (objDBName.selectedIndex <= 0)
    {
        alert("Please select a database to connect to");
        objDBName.focus();
        return false;
    }
    AjaxPro.timeoutPeriod = (parseInt(objConnectionTimeout.value, 10)+10) * 1000;
    objConnectToDatabase.style.display = "none";
    objConnectionInProgress.style.display = "block";
    objActivityMessage.innerHTML = "Connecting to the database <strong>" + objDBName.value + "</strong>. Please wait ...";
    Omega.Web.MSSQL._Default.CheckDatabaseConnection(objServerName.value, objDBName.value, authenticationType, objDomain.value, objUserName.value, objPassword.value, parseInt(objConnectionTimeout.value, 10), CheckDBConnectionStep2_CallBack);
    return false;
}

function CheckDBConnectionStep2_CallBack(response)
{
    retVal = response.value;
    if (retVal != "-1")
    {
        location.replace("Redirector.aspx");
    }
    else
    {
        alert("Unable to connect to specified database. Please make sure that you have permission to access the database.");
        objConnectToDatabase.style.display = "block";
        objConnectionInProgress.style.display = "none";
        objServerName.select();
    }
    return false;
}
