﻿function cbWriteOwnSql_OnClick(obj)
{
    if (obj.checked)
    {
        document.getElementsByName("tbSQL")[0].readOnly = false;
        SQLTabClicked(document.getElementsByName("SQL")[0]);
        document.getElementsByName("tbSQL")[0].focus();
    }
    else
    {
        document.getElementsByName("tbSQL")[0].value = "";
        document.getElementsByName("tbSQL")[0].readOnly = true;
        SQLTabClicked(document.getElementsByName("Tables")[0]);
    }
}

function SQLTabClicked(obj)
{
    if (! document.getElementsByName("cbWriteOwnSql")[0].checked)
    {
        if (sqlQueryType == "U")
        {
            updtSql = BuildUpdateQuery();
            if (updtSql == "") { return; }
            document.getElementsByName("tbSQL")[0].value = BuildUpdateQuery();
        }
        if (sqlQueryType == "D")
        {
            document.getElementsByName("tbSQL")[0].value = BuildDeleteQuery();
        }
        if (sqlQueryType == "S")
        {
            document.getElementsByName("tbSQL")[0].value = BuildSelectQuery();
        }
    }
    TabClicked2(obj);
}

function BuildUpdateQuery()
{
    var updateSQL = "UPDATE\t\t";
    if (jsCheckForUpdateColumns())
    {
        if (databaseObjects.length > 0)
        {
            updateSQL += databaseObjects[0].displayName;
        }
        updateSQL += "\n"
        updateSQL += "SET\t\t";
        for (var i=0; i<updateColumns.length; i++)
        {
            updateSQL += updateColumns[i].updateText;
            if (i < updateColumns.length-1) {updateSQL += ",\n\t\t"; }
        }
        var filterClauses = BuildAllQueryFilters();
        if (filterClauses != "")
        {
            updateSQL += "\n" + filterClauses;
        }
    }
    else
    {
        updateSQL = "";
    }
    return updateSQL;
}

function BuildDeleteQuery()
{
    var deleteSQL = "DELETE FROM\t"
    if (databaseObjects.length > 0)
    {
        deleteSQL += databaseObjects[0].displayName;
    }
    var filterClauses = BuildAllQueryFilters();
    if (filterClauses != "")
    {
        deleteSQL += "\n" + filterClauses;
    }
    return deleteSQL;
}

function BuildSelectQuery()
{
    var selectSQL = "SELECT\t\t"
    selectSQL += BuildAllSelectClauses();
    selectSQL += "\n"
    selectSQL += "FROM\t\t";
    var joinCaluses = BuildAllTableJoins();
    if (filterClauses != "")
    {
        selectSQL += joinCaluses;
    }
    var filterClauses = BuildAllQueryFilters();
    if (filterClauses != "")
    {
        selectSQL += "\n" + filterClauses;
    }
    
    var orderByClauses = BuildAllOrderByClauses();
    if (orderByClauses != "")
    {
        selectSQL += "\nORDER BY\t" + orderByClauses;
    }
    return selectSQL;
}

function btnTestSql_OnClick()
{
    var sqlString = "";
    var tmpSqlQueryType = "";
    HideAllPopups();
    if (document.getElementsByName("cbWriteOwnSql")[0].checked)
    {
        sqlString = trim(document.getElementsByName("tbSQL")[0].value);
        if (sqlString == "" || sqlString.length < 10) 
        {
            alert("Please specify a query to validate");
            return false;
        }
        if (sqlString.toUpperCase().substr(0, 6) == "SELECT")
        {
            tmpSqlQueryType = "S";
        }
        else if (sqlString.toUpperCase().substr(0, 6) == "UPDATE")
        {
            tmpSqlQueryType = "U";
        }
        else if (sqlString.toUpperCase().substr(0, 6) == "DELETE")
        {
            tmpSqlQueryType = "D";
        }
        else if (sqlString.toUpperCase().substr(0, 6) == "CREATE")
        {
            tmpSqlQueryType = "C";
        }
        else if (sqlString.toUpperCase().substr(0, 5) == "ALTER")
        {
            tmpSqlQueryType = "A";
        }
        else if (sqlString.toUpperCase().substr(0, 4) == "DROP")
        {
            tmpSqlQueryType = "P";
        }
        else if (sqlString.toUpperCase().substr(0, 4) == "EXEC")
        {
            tmpSqlQueryType = "E";
        }
        else
        {
            tmpSqlQueryType = "O";
        }
        if (tmpSqlQueryType == "D" && document.getElementsByName("dq")[0].value.toUpperCase() != "Y")
        {
            alert("DELETE queries are disabled by the administrator.");
            return false;
        }
        if (tmpSqlQueryType == "U" && document.getElementsByName("uq")[0].value.toUpperCase() != "Y")
        {
            
            alert(" 1 UPDATE queries are disabled by the administrator." + document.getElementsByName("uq")[0].value.toUpperCase());
            return false;
        }
        if (tmpSqlQueryType == "C" && document.getElementsByName("cq")[0].value.toUpperCase() != "Y")
        {
            alert("CREATE queries are disabled by the administrator.");
            return false;
        }
        if (tmpSqlQueryType == "A" && document.getElementsByName("aq")[0].value.toUpperCase() != "Y")
        {
            alert("ALTER queries are disabled by the administrator.");
            return false;
        }
        if (tmpSqlQueryType == "P" && document.getElementsByName("pq")[0].value.toUpperCase() != "Y")
        {
            alert("DROP queries are disabled by the administrator.");
            return false;
        }
        if (tmpSqlQueryType == "E" && document.getElementsByName("eq")[0].value.toUpperCase() != "Y")
        {
            alert("EXEC queries are disabled by the administrator.");
            return false;
        }
    }
    else
    {
        if (jsValidateQuery())
        {
            tmpSqlQueryType = sqlQueryType;
            if (sqlQueryType == "U")
            {
                sqlString = BuildUpdateQuery();
            }
            if (sqlQueryType == "D")
            {
                sqlString = BuildDeleteQuery();
            }
            if (sqlQueryType == "S")
            {
                sqlString = BuildSelectQuery();
            }
            document.getElementsByName("tbSQL")[0].value = sqlString;
        }
        else
        {
            return false;
        }
    }
    requestInProcess = true;
    ShowHidePleaseWaitPanel(true);
    Omega.Web.MSSQL.SqlBuilder.ValidateSql(sqlString, ValidateSql_CallBack);
    return false;
}

function ValidateSql_CallBack(resp)
{
    requestInProcess = false;
    ShowHidePleaseWaitPanel(false);
    alert(resp.value);
}

function btnExecuteSql_OnClick()
{
    HideAllPopups();
    var sqlString = "";
    var tmpSqlQueryType = "";
    if (document.getElementsByName("cbWriteOwnSql")[0].checked)
    {
        sqlString = trim(document.getElementsByName("tbSQL")[0].value);
        if (sqlString == "" || sqlString.length < 10) 
        {
            alert("Please specify a query to execute");
            return false;
        }
        if (sqlString.toUpperCase().substr(0, 6) == "SELECT")
        {
            tmpSqlQueryType = "S";
        }
        else if (sqlString.toUpperCase().substr(0, 6) == "UPDATE")
        {
            tmpSqlQueryType = "U";
        }
        else if (sqlString.toUpperCase().substr(0, 6) == "DELETE")
        {
            tmpSqlQueryType = "D";
        }
        else
        {
            tmpSqlQueryType = "O";
        }
        if (tmpSqlQueryType == "D" && document.getElementsByName("dq")[0].value.toUpperCase != "Y")
        {
            alert("Delete queries are not allowed.");
            return false;
        }
        if (tmpSqlQueryType == "U" && document.getElementsByName("uq")[0].value.toUpperCase != "Y")
        {
            alert("Update queries are not allowed.");
            return false;
        }
    }
    else
    {
        if (jsValidateQuery())
        {
            tmpSqlQueryType = sqlQueryType;
            if (sqlQueryType == "U")
            {
                sqlString = BuildUpdateQuery();
            }
            if (sqlQueryType == "D")
            {
                sqlString = BuildDeleteQuery();
            }
            if (sqlQueryType == "S")
            {
                sqlString = BuildSelectQuery();
            }
            document.getElementsByName("tbSQL")[0].value = sqlString;
        }
        else
        {
            return false;
        }
    }
    if (tmpSqlQueryType == "D")//ask for confirmation before deleting
    {
        if (! window.confirm("You are about to delete some records from the database. Are you sure you want to continue?"))
        {
            return false;
        }
    }
    requestInProcess = true;
    ShowHidePleaseWaitPanel(true);
    if (tmpSqlQueryType == "S")
    {
        document.form2.action = "DV.aspx";
        document.form2.q.value = sqlString;
        document.form2.w.value = "790";
        document.form2.h.value = "540";
        document.form2.f.value = "TabClicked_ResultSet";
        document.form2.submit();
    }
    else
    {
        Omega.Web.MSSQL.SqlBuilder.ExecuteNonSelectSql(sqlString, ExecuteNonSelectSql_CallBack);
    }
    return false;
}

function ExecuteNonSelectSql_CallBack(resp)
{
    ShowHidePleaseWaitPanel(false);
    alert(resp.value);
}

function jsValidateQuery()
{
    if (databaseObjects.length <= 0)
    {
        alert("Please select at least one table.");
        ReplicateBodyOnLoad(); 
        return false;
    }
    if (sqlQueryType == "S")
    {
        if (! jsCheckForSelectColumns())
        {
            return false;
        }
    }
    if (sqlQueryType == "U")
    {
        if (! jsCheckForUpdateColumns())
        {
            return false;
        }
    }
    return true;
}

function TabClicked_ResultSet()
{
    ShowHidePleaseWaitPanel(false);
    TabClicked2(document.getElementsByName("Resultset")[0]);
}