﻿var objUdttDesigner = null;
var objSchema = null;
var objUdttName = null;
var objColumnsPanel = null;
var objSQLPanel = null;
var objColumnsTab = null;
var objSQLTab = null;
var objTbSQL = null;
var objTablePleaseWait = null;
var objCellPleaseWaitMessage = null;

var objAddEditColumnPanel = null;
var objColumnsTable = null;
var objColumnName = null;
var objColumnDataType = null;
var objColumnLength = null;
var objColumnPrecision = null;
var objColumnScale = null;
var objIsPrimaryKey = null;
var objIsIdentityCol = null;
var objIdentitySeed = null;
var objIdentityIncrement = null;
var objNullAllowed = null;
var objIsRowGuid = null;
var objTbColumnDefault = null;
var objDdlDefault = null;
var objDdlRule = null;
var objCollation = null;
var objTbComputedColumn = null;
var objTbColumnCheckConstraint = null;
var objIsUnique = null;
var objRbIndexType = null;
var objCbIndexOptions = null;

var udttMode = "N";

function BodyOnLoad()
{
    try
    {
        objUdttDesigner = document.getElementsByName("tblUdttDesigner")[0];
        objSchema = document.form1.ddlSchema;
        objUdttName = document.form1.tbUdttName;
        objColumnsPanel = document.getElementsByName("pnlColumns")[0];
        objSQLPanel = document.getElementsByName("pnlSQL")[0];
        objColumnsTab = document.getElementsByName("tabColumns")[0];
        objSQLTab = document.getElementsByName("tabSQL")[0];
        
        objTbSQL = document.form1.tbSQL;
        objColumnsTable = document.getElementsByName("tblColumns")[0];
        
        objTablePleaseWait = document.getElementsByName("tblPleaseWait")[0];
        objCellPleaseWaitMessage = document.getElementsByName("cellPleaseWaitMessage")[0];
        InitColumnsPanel();
        btnNewColumn_OnClick();
    }
    catch (e)
    {
    }
}

function ColumnsTabClicked(obj)
{
    HideAddEditColumnPanel();
    objColumnsTab.className = "atabr";
    objSQLTab.className = "itabr";

    objColumnsPanel.style.display = "block";
    objSQLPanel.style.display = "none";
    return false;
}

function SQLTabClicked(obj)
{
    if (ValidateUserDefinedTableType())
    {
        HideAddEditColumnPanel();
        objColumnsTab.className = "itabr";
        objSQLTab.className = "atabr";

        objColumnsPanel.style.display = "none";
        objSQLPanel.style.display = "block";

        objTbSQL.value = "-- Preparing user defined table create script, please wait";
        Omega.Web.MSSQL.UserDefinedTableTypeDesigner.BuildCreateUserDefinedTableTypeSQLStatement(parseInt(document.form1.udttId.value, 10), trim(objSchema.value), trim(objUdttName.value), columns, BuildCreateUserDefinedTableTypeSQLStatement_Callback);
    }
    return false;
}

function BuildCreateUserDefinedTableTypeSQLStatement_Callback(resp)
{
    objTbSQL.value = resp.value;
    return false;
}

function btnTestSql_OnClick()
{
    HideAddEditColumnPanel();
    if (ValidateUserDefinedTableType())
    {
        objUdttDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = checkSqlText;
        Omega.Web.MSSQL.UserDefinedTableTypeDesigner.ValidateSql(parseInt(document.form1.udttId.value, 10), trim(objSchema.value), trim(objUdttName.value), columns, ValidateSql_Callback);
    }
    return false;
}

function ValidateSql_Callback(resp)
{
    alert(resp.value);
    objUdttDesigner.style.display = "block";
    objTablePleaseWait.style.display = "none";
}


function btnExecuteSql_OnClick()
{
    HideAddEditColumnPanel();
    if (ValidateUserDefinedTableType())
    {
        objUdttDesigner.style.display = "none";
        objTablePleaseWait.style.display = "block";
        objCellPleaseWaitMessage.innerHTML = savingTableText;
        Omega.Web.MSSQL.UserDefinedTableTypeDesigner.CreateUserDefinedTableType(parseInt(document.form1.udttId.value, 10), trim(objSchema.value), trim(objUdttName.value), columns, CreateUserDefinedTableType_Callback);
    }
    return false;
}

function CreateUserDefinedTableType_Callback(resp)
{
    respval = resp.value;
    isError = true;
    message = "Unable to update the database";
    if (respval != null)
    {
        respvalarray = respval.split("|");
        message = respvalarray[1];
        if (respval.charAt(0) == "0")
        {
            isError = false;
        }
    }
    alert(message);
    if (isError)
    {
        objUdttDesigner.style.display = "block";
        objTablePleaseWait.style.display = "none";
    }
    else
    {
        window.opener.UDTTDesignerComplete(udttMode, document.form1.udttId.value, trim(objUdttName.value));
        self.close();
    }
}

function ValidateUserDefinedTableType()
{
    objUdttName.value = trim(objUdttName.value);
    if (objUdttName.value == "")
    {
        alert("User Defined Table Type name is required");
        objUdttName.focus();
        return false;
    }
    numColumns = columns.length;
    for (var i=0; i<columns.length; i++)
    {
        if (columns[i].isColumnDeleted)
        {
            numColumns--;
        }
    }
    if (numColumns <= 0)
    {
        alert("Please define at least one column for the table");
        ColumnsTabClicked(null);
        btnNewColumn_OnClick();
        return false;
    }
    return true;
}

